
# Assign a descriptive name to each MODULE

define RED D1
define GREEN D2
define BLUE D3
define WHITE D4

# Equate the BRIGHT command to DIM 100 %.
#            FADE command to DIM 0 %.

define BRIGHT DIM 100
define FADE DIM 0

# Let's start by turning all modules ON, Then fade all but RED

RED ON
GREEN ON
BLUE ON
WHITE ON

GREEN FADE
BLUE FADE
WHITE FADE

# This identifies the main outer loop.

:outer

# At this point, only the RED lights are BRIGHT.
# Cycle through each color as follows...
#   1) Fade up GREEN  (so GREEN and RED are BRIGHT)
#   2) Dim RED (so only GREEN is BRIGHT)
#   3) Fade up BLUE  (so GREEN and BLUE are BRIGHT)
#   4) Dim GREEN (so only BLUE is BRIGHT)
#   5) Fade up WHITE  (so BLUE and WHITE are BRIGHT)
#   6) Dim BLUE (so only WHITE is BRIGHT)
#   7) Fade up RED  (so WHITE and RED are BRIGHT)
#   8) Dim WHITE (so only RED is BRIGHT)


:inner

GREEN BRIGHT
RED FADE
BLUE BRIGHT
GREEN FADE
WHITE BRIGHT
BLUE FADE
RED BRIGHT
WHITE FADE


# Now we're at the same point where we started.
# Let's repeat these last few steps once again. 
# Note the '2' in the next command which means repeat twice.

GOTO inner 2


# Once the commands following the ":inner" label have been executed twice,
# The interpreter continues executing the remaining commands.
# Let's brighten all the lights...

GREEN BRIGHT
BLUE BRIGHT
WHITE BRIGHT

# Wait 5 seconds...

DELAY 5

# Now DIM all but the RED

GREEN BRIGHT
BLUE BRIGHT
WHITE BRIGHT

# Now jump back to the ":outer" label. This sequence will continue forever till
# the <ESC> key is pressed (which will jump to the label ":EXIT"), or when
# CNTL-C is detected, which causes the interpreter to terminate immediately.

GOTO outer

# The ":EXIT" label is searched for by the interpreter whenever the <ESC>
# key is pressed. This allows the interpreter to execute a controlled shutdown.

:EXIT

RED OFF
GREEN OFF
BLUE OFF
WHITE OFF
